=== debian/changelog ===
jicmp (1.0.12-1) unstable; urgency=low

  * updated to new version

 -- Benjamin Reed <ranger@opennms.org>  Thu, 18 Nov 2010 14:53:00 -0500

jicmp (1.0.8-1) unstable; urgency=low

  * updated to new version, incorporated some build modernization from topquark

 -- Benjamin Reed <ranger@opennms.org>  Tue, 15 Apr 2008 12:17:00 -0500

jicmp (1.0.7-1) unstable; urgency=low

  * updated to new version

 -- Benjamin Reed <ranger@opennms.org>  Wed, 13 Feb 2008 16:28:00 -0500

jicmp (1.0-1) unstable; urgency=low

  * Initial release as separately versioned package

 -- Jeff Gehlbach <jeffg@opennms.org>  Sat, 28 Jul 2007 20:32:20 -0400
